#include <bits/stdc++.h>

using namespace std;
using ll = long long;

bool flag = false;
ll s;
vector<pair<int, int>> ans;

void rec(int i, int n, int m, vector<int> &cnt, vector<vector<ll>> &a) {
    if (!flag) {
        if (i == m) {
            unordered_map<ll, pair<int, int>> prev;
            vector<ll> sums(n);
            for (int j = 0; j < n; j++) {
                ll sum = 0;
                for (int k = 0; k < m; k++) {
                    if (cnt[k] == 1) {
                        sum += a[j][k];
                    }
                }
                sums[j] = sum;
                if (prev[sum].first == 0) {
                    prev[sum].first = -1;
                    prev[sum].second = j + 1;
                }
                for (auto ma: prev) {
                    if (prev[ma.first + sum].first == 0) {
                        prev[ma.first + sum].first = prev[ma.first].second;
                        prev[ma.first + sum].second = j + 1;
                    }
                }
            }
            if (!flag && prev[s].first != 0) {
                ll cur = s;
                vector<int> p(n, 0);
                while (prev[cur].first != -1) {
                    p[prev[cur].second - 1]++;
                    cur -= sums[prev[cur].second - 1];
                }
                p[prev[cur].second - 1]++;
                for (int j = 0; j < n; j++) {
                    if (p[j] == 0) {
                        ans.emplace_back(1, j + 1);
                    }
                }
                for (int k = 0; k < m; k++) {
                    if (cnt[k] == -1) {
                        ans.emplace_back(2, k + 1);
                    }
                }
                flag = true;
            }
            return;
        }
        cnt[i] = -1;
        rec(i + 1, n, m, cnt, a);
        cnt[i] = 1;
        rec(i + 1, n, m, cnt, a);
    }
}


int main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
    int n, m;
    cin >> n >> m;
    vector<vector<ll>> a(n, vector<ll>(m));
    vector<int> cnt(m, 0);
    for (int i = 0; i < n; i++) {
        for (int j = 0; j < m; j++) {
            cin >> a[i][j];
        }
    }
    cin >> s;
    rec(0, n, m, cnt, a);
    if (flag) {
        cout << "YES\n";
        cout << ans.size() << "\n";
        for (auto ma: ans) {
            cout << ma.first << " " << ma.second << "\n";
        }
    } else {
        cout << "NO\n";
    }
    return 0;
}