#include <bits/stdc++.h>

using namespace std;
using ll = long long;

void dfs(int cur, vector<vector<int>> &graph, vector<int> &ans) {
    for (int u: graph[cur]) {
        dfs(u, graph, ans);
        ans[cur] = max(ans[cur], ans[u] + 1);
    }
}

int main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);
    int n, k, t;
    cin >> n >> k >> t;
    vector<vector<int>> graph(n, vector<int>());
    vector<int> ans(n);
    bool bamb = true;
    for (int i = 0; i < n - 1; i++) {
        int u, v;
        cin >> u >> v;
        graph[u - 1].push_back(v - 1);
        if (u + 1 != v) {
            bamb = false;
        }
    }
    dfs(0, graph, ans);
    if (bamb) {
        int res = 0;
        for (int i = 1; i < n - k; i++) {
            res = max(res, ans[i]);
        }
        cout << res;
    } else {

    }
    return 0;
}