#include <bits/stdc++.h>

using namespace std;
using ll = long long;

void dfs(int cur, vector<vector<int>> &graph, vector<int> &ans, vector<bool> &used) {
    ans[cur] = 0;
    queue<int> q;
    q.push(cur);
    while (!q.empty()) {
        int u = q.front();
        used[u] = true;
        q.pop();
        for (int h: graph[u]) {
            if (!used[h]) {
                ans[h] = ans[u] + 1;
                used[h] = true;
                q.push(h);
            }
        }
    }
}

int main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);
    int n, k, t;
    cin >> n >> k >> t;
    vector<vector<int>> graph(n, vector<int>());
    vector<int> ans(n);
    vector<bool> used(n);
    for (int i = 0; i < n - 1; i++) {
        int u, v;
        cin >> u >> v;
        graph[u - 1].push_back(v - 1);
    }
    int res = 1e9;
    for (int i = 1; i < n; i++) {
        graph[0].push_back(i);
        dfs(0, graph, ans, used);
        int j = 0;
        for (int f = 0; f < n; f++) {
            j = max(ans[f], j);
        }
        res = min(res, j);
        graph[0].pop_back();
    }
    cout << res << "\n";
    return 0;
}