#include <bits/stdc++.h>

using namespace std;
using ll = long long;

void dfs(int cur, vector<vector<int>> &graph, vector<int> &ans) {
    ans[cur] = 0;
    queue<int> q;
    q.push(cur);
    while (!q.empty()) {
        int u = q.front();
        for (int h: graph[u]) {
            ans[h] = ans[u] + 1;
            q.push(h);
        }
        q.pop();
    }
}

int main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);
    int n, k, t;
    cin >> n >> k >> t;
    vector<vector<int>> graph(n, vector<int>());
    vector<int> ans(n);
    bool bamb = true;
    for (int i = 0; i < n - 1; i++) {
        int u, v;
        cin >> u >> v;
        graph[u - 1].push_back(v - 1);
    }
    int res = 1e9;
    for (int i = 1; i < n; i++) {
        graph[0].push_back(i);
        dfs(0, graph, ans);
        int j = 0;
        for (int f = 0; f < n; f++) {
            j = max(ans[f], j);
        }
        res = min(res, j);
    }
    cout << res << "\n";
    return 0;
}